#include <iostream.h>

class Nodo 
{
	public:
		int Info;
		Nodo *Next;
		Nodo(int Num, Nodo *N);
};  /* fine dichiarazione classe Nodo*/


Nodo::Nodo(int Num, Nodo *N)  /* costruttore crea un Nodo contenente un valore intero*/
{  
	Info = Num;
	Next = N;
}
	
class Pila 
{
	public:
		Nodo *P;
		Pila();
		~Pila();
		Nodo *Pop();
		void Push(Nodo *N);
		void Stampa();

};  /* fine classe Pila*/



	
int main()
{  

	Pila *P1 = new Pila();
	for(int i=0; i<4; i++)
	{
		Nodo *Temp= new Nodo(i*10, NULL);
		P1->Push(Temp);  
	}
	P1->Stampa();
	P1->Pop();
	cout << "------" << endl;
	P1->Stampa();
	return(0);
}
			
	
		Pila::Pila()  /* costruttore crea una Pila vuota*/
		{  
			P=NULL;
			
     		}
		Pila::~Pila()
		{  
			while(P!=NULL)
			{	Nodo *Temp=P;
				P=P->Next;
				Temp=P; 
				delete Temp;	 
			}

		}

		Nodo *Pila::Pop()
		{  
			Nodo *N;
			if (P != NULL)
			{  
				N=P;
				P=P->Next;
				N->Next=NULL;
			}
			else
				cout << "Pila Underflow";     		
     		return(N);
		}

		void Pila::Push(Nodo *N)
		{  
			N->Next=P;
			P=N;
		}

		void Pila::Stampa()
		{  Nodo *Temp=P;
			while(Temp!=NULL)
			{
				cout << Temp->Info << endl;
				Temp=Temp->Next;  
			}

		}

